﻿/*
 * The MIT License (MIT)
Copyright (c) 2013 João Tiago Pinheiro Neto Jacob
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*
*/


using UnityEngine;
using System.Collections;

public class CameraTexture : MonoBehaviour {

	WebCamTexture camFeed;

    IEnumerator Start()
    {
        /*WebCamDevice[] devices = WebCamTexture.devices;
        var deviceName = devices[0].name;
        var wct = new WebCamTexture(deviceName, 400, 300, 12);
        GameObject.Find("Background Image").guiTexture.texture = wct;
        wct.Play();*/
        yield return Application.RequestUserAuthorization(UserAuthorization.WebCam | UserAuthorization.Microphone);
        if (Application.HasUserAuthorization(UserAuthorization.WebCam | UserAuthorization.Microphone))
        {
            for (int cameraIndex = 0; cameraIndex < WebCamTexture.devices.Length; cameraIndex++)
            {
                // We want the back camera
                if (!WebCamTexture.devices[cameraIndex].isFrontFacing || WebCamTexture.devices.Length == 1)
                {
                    camFeed = new WebCamTexture(WebCamTexture.devices[cameraIndex].name);
                    var backgroundImage = GameObject.Find("Background Image");
                    backgroundImage.guiTexture.texture = camFeed;
                    switch (camFeed.videoRotationAngle)
                    {
                        case 90:
                            backgroundImage.transform.localScale = new Vector3(-1,-1,1);
                            break;
                        case 180:
                            backgroundImage.transform.localScale = new Vector3(1, -1, 1);
                            break;
                    }
                   
                    // if (camFeed != null && Application.platform == RuntimePlatform.Android)
                    camFeed.Play();
                }
                   

                // camFeed = new WebCamTexture(cameraIndex, Screen.width, Screen.height);
            }

          

           
            //bgimg.guiTexture.texture = camFeed;
        }
        else
        {
        }
		// Checks how many and which cameras are available on the device
	
      
    }
}
